Show / Hide Table of Contents

# Class Window

A toplevel view that draws a frame around its region and has a "ContentView" subview where the contents are added.

##### Inheritance

System.Object
Responder
View
Toplevel
Window
Dialog

##### Inherited Members

Toplevel.CanFocus
Toplevel.Create()
Toplevel.ProcessKey(KeyEvent)
Toplevel.Running
Toplevel.WillPresent()
View.Add(View[])
View.AddRune(Int32, Int32, Rune)
View.Bounds
View.ChildNeedsDisplay()
View.Clear()
View.Clear(Rect)
View.ClearNeedsDisplay()
View.ClipToBounds()
View.ColorScheme
View.DrawFrame(Rect, Int32, Boolean)
View.DrawHotString(ustring, Boolean, ColorScheme)
View.DrawHotString(ustring, Attribute, Attribute)
View.Driver
View.EnsureFocus()
View.Focused
View.FocusFirst()
View.FocusLast()
View.FocusNext()
View.FocusPrev()
View.Frame
View.HasFocus
View.Height
View.Id
View.LayoutStyle
View.LayoutSubviews()
View.MostFocused
View.Move(Int32, Int32)
View.PositionCursor()
View.ProcessColdKey(KeyEvent)
View.ProcessHotKey(KeyEvent)
View.ScreenToView(Int32, Int32)
View.SetClip(Rect)
View.SetFocus(View)
View.SetNeedsDisplay()
View.SetNeedsDisplay(Rect)
View.Subviews
View.SuperView
View.ToString()
View.WantMousePositionReports
View.Width
View.X
View.Y

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class Window : Terminal.Gui.Toplevel, System.Collections.IEnumerable

### Constructors

#### Window(ustring)

Initializes a new instance of the Window class with an optional title.

##### Declaration

    public Window (NStack.ustring title = null);

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | title | Title.

#### Window(ustring, Int32)

Initializes a new instance of the Window with the specified frame for its location, with the specified border an optional title.

##### Declaration

    public Window (NStack.ustring title = null, int padding = 0);

##### Parameters

Type | Name | Description
--- | --- | ---
NStack.ustring | title | Title.
System.Int32 | padding | Number of characters to use for padding of the drawn frame.

#### Window(Rect, ustring)

Initializes a new instance of the Terminal.Gui.Gui.Window class with an optional title and a set frame.

##### Declaration

    public Window (Terminal.Gui.Rect frame, NStack.ustring title = null);

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | frame | Frame.
NStack.ustring | title | Title.

#### Window(Rect, ustring, Int32)

Initializes a new instance of the Window with the specified frame for its location, with the specified border an optional title.

##### Declaration

    public Window (Terminal.Gui.Rect frame, NStack.ustring title = null, int padding = 0);

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | frame | Frame.
NStack.ustring | title | Title.
System.Int32 | padding | Number of characters to use for padding of the drawn frame.

### Properties

#### Title

The title to be displayed for this window.

##### Declaration

    public NStack.ustring Title { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring | The title.

### Methods

#### Add(View)

Add the specified view to the ContentView.

##### Declaration

    public override void Add (Terminal.Gui.View view);

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | View to add to the window.

#### GetEnumerator()

Enumerates the various views in the ContentView.

##### Declaration

    public System.Collections.IEnumerator GetEnumerator ();

##### Returns

Type | Description
--- | ---
System.Collections.IEnumerator | The enumerator.

#### MouseEvent(MouseEvent)

##### Declaration

    public override bool MouseEvent (Terminal.Gui.MouseEvent mouseEvent);

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | mouseEvent | To be added.

##### Returns

Type | Description
--- | ---
System.Boolean | To be added.

#### Redraw(Rect)

##### Declaration

    public override void Redraw (Terminal.Gui.Rect bounds);

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds | To be added.

#### Remove(View)

Removes a widget from this container.

##### Declaration

    public override void Remove (Terminal.Gui.View view);

##### Parameters

Type | Name | Description
--- | --- | ---
View | view | To be added.

#### RemoveAll()

Removes all widgets from this container.

##### Declaration

    public override void RemoveAll ();